#include "simulation.h"
#include "random.h"
#include "ptaci.h"

//-------------------------------SHO demo-------------------------------- 
class TService;

CHead     *Queue;                              
TService  *Service;                              

#define MINX		-499
#define MAXX		499

class TPtak : public CProcess                 // request in the queueing system
{
    virtual void Run();                            // request's behaviour
  public:
    unsigned char id;
};

void TPtak::Run()
{
    id = 0;
    while (1) {

	printf("cas=%d  ptak %d je na pozici (%d,%d)  ", (int) Time(), id, ptaci_x[id], ptaci_y[id]);
	if (ptaci_udalost[id]) printf(">>> ptak vygeneroval udalost, kterou je treba hlasit.");
	printf("\n");
	
	Passivate();
    }
}

/*----------------------------------------------*/
void CSimulation::Run()                          // main process
{
    TPtak *p = new TPtak();         // vytvor ptaka

    while (nacti_dalsi_zaznamy()) {
	p->ActivateAt( Time());
	Hold(1);
    }
    printf("Konec simulace.\n");
};
